
.DEF	RES		=	R0
.DEF	ONE		=	R1
.DEF	L		=	R2
.DEF	H		=	R3
.DEF	MEMPTRL	=	R4
.DEF	MEMPTRH	=	R5
.DEF	_C		=	R6
.DEF	_B		=	R7
.DEF	IYL		=	R8
.DEF	IYH		=	R9
.DEF	IXL		=	R10
.DEF	IXH		=	R11
.DEF	R		=	R12
.DEF	ROMID	=	R13
.DEF	ZERO	=	R14
.DEF	BUFH	=	R15



.DEF	A		=	R16
.DEF	F		=	R17
.DEF	C		=	R18
.DEF	B		=	R19
.DEF	E		=	R20
.DEF	D		=	R21
.DEF	CONST128=	R22
.DEF	BUF		=	R23
.DEF	TMPL	=	R24
.DEF	TMPH	=	R25
.DEF	PCL		=	R26
.DEF	PCH		=	R27
.DEF	STPL	=	R28
.DEF	STPH	=	R29

.EQU	REGBADDR=	19
.EQU	REGCADDR=	18
.EQU	REGDADDR=	21
.EQU	REGEADDR=	20
.EQU	REGHADDR=	03
.EQU	REGLADDR=	02
.EQU	REGRESADDR=	00
.EQU	REGAADDR=	16
.EQU	REGBUFADDR=	23
.EQU	REGBUFHADDR=15


.EQU	_H		=	TCNT1L
.EQU	_L		=	UBRR0L
.EQU	_D		=	EICRB;OCR1BL
.EQU	_E		=	OCR0
.EQU	_RES	=	TCNT2
.EQU	I		=	OCR1AL
.EQU	_A		=	OCR2
.EQU	_F		=	TCNT0
.EQU	CONTROL	=	PORTA;EIMSK;ICR1L-BAD

.EQU	ADDR3	=	UBRR1H
.EQU	ADDR2	=	UBRR1L
.EQU	ADDR1	=	TWAR

.EQU	MUXA14	=	0		; PORTB
.EQU	SCK2	=	1		; PORTB
.EQU	MUXA15	=	2		; PORTB
.EQU	TOTAPE	=	3		; PORTB
.EQU	BEEP	=	4		; PORTB
.EQU	NBEEP	=	5		; PORTB
.EQU	MUXA16	=	6		; PORTB
.EQU	MUXA17	=	7		; PORTB

.EQU	A14_CPU	=	6		; PORTC
.EQU	A15_CPU	=	7		; PORTC

.EQU	TOVCPU	=	0		; PORTD
;.EQU	MINT	=	1		; PORTD
.EQU	TOCPU	=	2		; PORTD
.EQU	BORDERL	=	3		; PORTD
.EQU	BORDERM	=	4		; PORTD
.EQU	BORDERH	=	5		; PORTD
.EQU	BORDERY	=	6		; PORTD
.EQU	A16		=	7		; PORTD

.EQU	KEYCLK	=	0		; PORTE
.EQU	KEYDATA	=	1		; PORTE
.EQU	SCRA16	=	2		; PORTE
.EQU	MINT	=	3		; PORTE
.EQU	RBBCP	=	7		; PORTE

.EQU	KEYL	=	0		; PORTF
.EQU	INTF11	=	0		; PORTF
.EQU	KEYML	=	1		; PORTF
.EQU	INTF12	=	1		; PORTF
.EQU	KEYM	=	2		; PORTF
.EQU	INTFLG	=	2		; PORTF
.EQU	KEYMH	=	3		; PORTF
.EQU	KEYH	=	4		; PORTF
.EQU	KEYEXT	=	5		; PORTF
.EQU	FROMTAPE=	6		; PORTF


.EQU	II		=	7		; F
.EQU	TT		= 	6		; F
.EQU	HH		= 	5		; F
.EQU	SS		= 	4		; F
.EQU	PP		= 	3		; F
.EQU	VV		= 	3		; F
.EQU	NN		= 	2		; F
.EQU	ZZ		= 	1		; F
.EQU	CC		= 	0		; F

.EQU	IFF2	=	7		; CONTROL
.EQU	IFF1	=	6		; CONTROL
.EQU	SNDE	=	5		; CONTROL
.EQU	R_7		=	4		; CONTROL
.EQU	WD7FFD	=	3		; PORT 0X7FFD WRITE DISABLE
.EQU	SYS		=	2		; CONTROL - SYSTEM BIT = 1 AFTER SYSTEM START
.EQU	IMH		=	1		; CONTROL
.EQU	IML		=	0		; CONTROL

.EQU	ROMIDBIT=	6		; ROMID		ROM SELECT BIT:	0 - MAIN ROM (48), 1 - AUX ROM (128);


.EQU	PAGETBL	=	0X0400	; RAM PAGE MULTIPLEXOR DATA TABLE ADDRESS


