;********************** MEMORY MAP: ********************8
;
; 10FF - 0440 - MAIN SCREEN AREA (17 COLOMNS FROM 0, POINTED BY Z-PAIR
; 043F - 0140 - BUFIBUT AREA, POINTED BY Y-PAIR
; CONTROL:7 - BIT OF ATRIBUT INVERSIOL
; CONTROL 3-0: COUNTER

.INCLUDE "m128def.inc"
.INCLUDE "REGDEF.inc"
.INCLUDE "MACROSES.inc"
.INCLUDE "VECTORDESCRIPTOR.inc"
.INCLUDE "IOCONFIG.inc"
.INCLUDE "initialising.inc"


;********************************** VIDEO DATA AND BUFIBUTS IS ALLREADY PREPARED ***********************	

STRLOOP:POP		BUF						;                                         1,2
		VIDEOSTRING						; SEND VIDEOSTRING                        3-770

;************************************************ BORDER ***********************************************


		OUT		PORTE,BORDER			; SET CURRENT BORDER                      771
		
WRF0:	SBIS	PINE,RBBCP				; * 
		RJMP	WRF0					; * 
		LDD		VDATA0,Z+0				; * 
		CORRECTOR1						; *
		SBIS	PINE,RBBCP				; * 
		RJMP	WRF0					; * 7                                     778

WRF1:	SBIS	PINE,RBBCP				; * 
		RJMP	WRF1					; * 
		LDD		VDATA1,Z+1				; * 
		CORRECTOR1						; *
		SBIS	PINE,RBBCP				; * 
		RJMP	WRF1					; * 7                                     785

WRF2:	SBIS	PINE,RBBCP				; * 
		RJMP	WRF2					; * 
		LDD		VDATA2,Z+2				; * 
		CORRECTOR1						; *
		SBIS	PINE,RBBCP				; * 
		RJMP	WRF2					; * 7                                     792

WRF3:	SBIS	PINE,RBBCP				; * 
		RJMP	WRF3					; * 
		LDD		VDATA3,Z+3				; * 
		CORRECTOR1						; *
		SBIS	PINE,RBBCP				; * 
		RJMP	WRF3					; * 7                                     799

WRF4:	SBIS	PINE,RBBCP				; * 
		RJMP	WRF4					; * 
		LDD		VDATA4,Z+4				; * 
		CORRECTOR1						; *
		SBIS	PINE,RBBCP				; * 
		RJMP	WRF4					; * 7                                     806

WRF5:	SBIS	PINE,RBBCP				; * 
		RJMP	WRF5					; * 
		LDD		VDATA5,Z+5				; * 
		CORRECTOR1						; *
		SBIS	PINE,RBBCP				; * 
		RJMP	WRF5					; * 7                                     813

WRF6:	SBIS	PINE,RBBCP				; * 
		RJMP	WRF6					; * 
		LDD		VDATA6,Z+6				; * 
		CORRECTOR1						; *
		SBIS	PINE,RBBCP				; * 
		RJMP	WRF6					; * 7                                     820

WRF7:	SBIS	PINE,RBBCP				; * 
		RJMP	WRF7					; * 
		LDD		VDATA7,Z+7				; * 
		CORRECTOR1						; *
		SBIS	PINE,RBBCP				; * 
		RJMP	WRF7					; * 7                                     827

WRF8:	SBIS	PINE,RBBCP				; * 
		RJMP	WRF8					; * 
		LDD		VDATA8,Z+8				; * 
		CORRECTOR1						; *
		SBIS	PINE,RBBCP				; * 
		RJMP	WRF8					; * 7                                     834

WRF9:	SBIS	PINE,RBBCP				; * 
		RJMP	WRF9					; * 
		LDD		VDATA9,Z+9				; * 
		CORRECTOR1						; *
		SBIS	PINE,RBBCP				; * 
		RJMP	WRF9					; * 7                                     841

WRF10:	SBIS	PINE,RBBCP				; * 
		RJMP	WRF10					; * 
		LDD		VDATA10,Z+10			; * 
		CORRECTOR1						; *
		SBIS	PINE,RBBCP				; * 
		RJMP	WRF10					; * 7                                     848

WRF11:	SBIS	PINE,RBBCP				; * 
		RJMP	WRF11					; * 
		LDD		VDATA11,Z+11			; * 
		CORRECTOR1						; *
		SBIS	PINE,RBBCP				; * 
		RJMP	WRF11					; * 7                                     855

WRF12:	SBIS	PINE,RBBCP				; * 
		RJMP	WRF12					; * 
		LDD		VDATA12,Z+12			; * 
		CORRECTOR1						; *
		SBIS	PINE,RBBCP				; * 
		RJMP	WRF12					; * 7                                     862
		
WRF13:	SBIS	PINE,RBBCP				; * 
		RJMP	WRF13					; * 
		LDD		VDATA13,Z+13			; * 
		CORRECTOR1						; *
		SBIS	PINE,RBBCP				; * 
		RJMP	WRF13					; * 7                                     869
	
		LDI		ZH,0X10					;                                         870
		IN		ZL,TCNT1L				;                                         871
		IJMP							;                                         873

.ORG	0X1000
		
		NOP                             ;                                         874
		NOP                             ;                                         875
		NOP                             ;                                         876
		NOP                             ;                                         877
		NOP                             ;                                         878
		NOP                             ;                                         879
		NOP                             ;                                         880
		NOP                             ;                                         
		NOP                             ;                                         
		NOP                             ;                                         
		NOP                             ;                                         		
		NOP                             ;                                         		
		NOP                             ;                                         		
		NOP                             ;                                         		
		NOP                             ;                                         		
		NOP                             ;                                         		
		NOP                             ;                                         890
		NOP                             ;                                         
		NOP                             ;                                         
		NOP                             ;                                         
		NOP                             ;                                         		
		NOP                             ;                                         		
		NOP                             ;                                         		
		NOP                             ;                                         		
		NOP                             ;                                         		
		NOP                             ;                                         		
		NOP                             ;                                         900
		NOP                             ;                                         
		NOP                             ;                                         
		NOP                             ;                                         
		NOP                             ;                                         		
		NOP                             ;                                         		
		NOP                             ;                                         		
		NOP                             ;                                         		
		NOP                             ;                                         		
		NOP                             ;                                         		
		NOP                             ;                                         910
		NOP                             ;                                         
		NOP                             ;                                         
		NOP                             ;                                         
		NOP                             ;                                         		
		NOP                             ;                                         		
		NOP                             ;                                         		
		NOP                             ;                                         		
		NOP                             ;                                         		
		NOP                             ;                                         		
		NOP                             ;                                         920		
		NOP                             ;                                         
		NOP                             ;                                         
		NOP                             ;                                         
		NOP                             ;                                        
		NOP                             ;                                         
		NOP                             ;                                         926
		NOP                             ;                                         927
		NOP                             ;                                         928
		NOP								;                                         929		
		NOP                             ;                                         930
		NOP								;                                         931
		NOP								;                                         932
		NOP								;                                         933
		NOP								;                                         934
		NOP								;                                         935
		NOP								;                                         936
		NOP								;                                         937
		NOP								;                                         938
		NOP								;                                         939
		NOP								;                                         940
		NOP								;                                         941
		NOP								;                                         942
		NOP								;                                         943
		NOP								;                                         944
		NOP								;                                         945
		NOP								;                                         946
		NOP								;                                         947
		NOP								;                                         948
		NOP								;                                         949
		NOP								;                                         950
		NOP								;                                         951
		NOP								;                                         952
		NOP								;                                         953
		NOP								;                                         954
		NOP								;                                         955
		NOP								;                                         956
		NOP								;                                         957
		NOP								;                                         958
		NOP								;                                         959
		NOP								;                                         960
		NOP								;                                         961
		NOP								;                                         962
		NOP								;                                         963
		NOP								;                                         964
		NOP								;                                         965
		NOP								;                                         966
		NOP								;                                         967
		NOP								;                                         968
		NOP								;                                         969
		NOP								;                                         970
		NOP								;                                         971
		NOP								;                                         972
		NOP								;                                         973
		NOP								;                                         974
		NOP								;                                         975
		NOP								;                                         976
		NOP								;                                         977
		NOP								;                                         978
		NOP								;                                         979
		NOP								;                                         980
		NOP								;                                         981
		NOP								;                                         982
		NOP								;                                         983
		NOP								;                                         984
		NOP								;                                         985
		NOP								;                                         986
		NOP								;                                         987
		NOP								;                                         988
		NOP								;                                         989
		NOP								;                                         990
		NOP								;                                         991
		NOP								;                                         992
		RJMP	RS1						;                                         994
		NOP								; 79
		NOP								; 7A
		NOP								; 7B
		NOP								; 7C
		NOP								; 7D
		NOP								; 7E
		NOP								; 7F
		NOP								; 80
		NOP								; 81
		NOP								; 82
		NOP								; 83
		NOP								; 84
		NOP								; 85
		NOP								; 86
		NOP								; 87
		NOP								; 88
		NOP								; 89
		NOP								; 8A
		NOP								; 8B
		NOP								; 8C
		NOP								; 8D
		NOP								; 8E
		NOP								; 8F
		NOP								; 90

RS1:	STS		PORTF,VDATA20			; ************ RESET SYNC ************    995-996
		MOVW	ZL,VDATA24				; 1 LOAD VIDEOSTRIND ADDRESS TO ZH:L      997
		OUT		TCNT1L,VDATA20			;                                         998

WRF14:	SBIS	PINE,RBBCP				; * 
		RJMP	WRF14					; * 
		LDD		VDATA14,Z+14			; * 
		CORRECTOR1						; *
		SBIS	PINE,RBBCP				; * 
		RJMP	WRF14					; * 7                                     1005
		
WRF15:	SBIS	PINE,RBBCP				; * 
		RJMP	WRF15					; * 
		LDD		VDATA15,Z+15			; * 
		CORRECTOR1						; *
		SBIS	PINE,RBBCP				; * 
		RJMP	WRF15					; * 7                                     1012		
		
WRF16:	SBIS	PINE,RBBCP				; * 
		RJMP	WRF16					; * 
		LDD		VDATA16,Z+16			; * 
		CORRECTOR1						; *
		SBIS	PINE,RBBCP				; * 
		RJMP	WRF16					; * 7                                     1019		
		                                        
WRF17:	SBIS	PINE,RBBCP				; * 
		RJMP	WRF17					; * 
		LDD		VDATA17,Z+17			; * 
		CORRECTOR1						; * 
		SBIS	PINE,RBBCP				; * 
		RJMP	WRF17					; * 7                                     1126

WRF18:	SBIS	PINE,RBBCP				; * 
		RJMP	WRF18					; * 
		LDD		VDATA18,Z+18			; * 
		CORRECTOR1						; * 
		SBIS	PINE,RBBCP				; * 
		RJMP	WRF18					; * 7                                     1133

		LDI		ZH,0X11					;                                         1034
		IN		ZL,TCNT1L				;                                         1035
		IJMP							;                                         1037


.ORG	0X1124
		
		NOP								;                                         1038
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         1045
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         1055
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         1065
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         1075
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         1080
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         1090
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		RJMP	SS1						;                                         1096
		NOP								; 5F
		NOP								; 60
		NOP								; 61
		NOP								; 62
		NOP								; 63
		NOP								; 64
		NOP								; 65
		NOP								; 66
		NOP								; 67
		NOP								; 68
		NOP								; 69
		NOP								; 6A
		NOP								; 6B
		NOP								; 6C
		NOP								; 6D
		NOP								; 6E
		NOP								; 6F
		NOP								; 70
		NOP								; 71
		NOP								; 72
		NOP								; 73
		NOP								; 74
		NOP								; 75
		NOP								; 76
		NOP								; 77
		NOP								; 78
		NOP								; 79
		NOP								; 7A
		NOP								; 7B
		NOP								; 7C
		NOP								; 7D
		NOP								; 7E
		NOP								; 7F

SS1:	STS		PORTF,VDATA21			; ************* SET SYNC *************    1098
		OUT		PORTE,BORDER			; SET CURRENT BORDER                      1099
		MOVW	ZL,VDATA24				; 1 LOAD VIDEOSTRIND ADDRESS TO ZH:L      1100
		OUT		TCNT1L,VDATA22			;                                         1101

WRF19:	SBIS	PINE,RBBCP				; * 
		RJMP	WRF19					; * 
		LDD		VDATA19,Z+19			; * 
		CORRECTOR1						; * 
		SBIS	PINE,RBBCP				; * 
		RJMP	WRF19					; * 7                                     1108

WRF20:	SBIS	PINE,RBBCP				; * 
		RJMP	WRF20					; * 
		LDD		VDATA20,Z+20			; * 
		CORRECTOR1						; * 
		SBIS	PINE,RBBCP				; * 
		RJMP	WRF20					; * 7                                     1115

WRF21:	SBIS	PINE,RBBCP				; * 
		RJMP	WRF21					; * 
		LDD		VDATA21,Z+21			; * 
		CORRECTOR1						; * 
		SBIS	PINE,RBBCP				; * 
		RJMP	WRF21					; * 7                                     1121

WRF22:	SBIS	PINE,RBBCP				; * 
		RJMP	WRF22					; * 
		LDD		VDATA22,Z+22			; * 
		CORRECTOR1						; * 
		SBIS	PINE,RBBCP				; * 
		RJMP	WRF22					; * 7                                     1129

WRF23:	SBIS	PINE,RBBCP				; * 
		RJMP	WRF23					; * 
		LDD		VDATA23,Z+23			; * 
		CORRECTOR1						; * 
		SBIS	PINE,RBBCP				; * 
		RJMP	WRF23					; * 7                                     1136

WRF24:	SBIS	PINE,RBBCP				; * 
		RJMP	WRF24					; * 
		LDD		VDATA24,Z+24			; * 
		CORRECTOR1						; * 
		SBIS	PINE,RBBCP				; * 
		RJMP	WRF24					; * 7                                     1143

WRF25:	SBIS	PINE,RBBCP				; * 
		RJMP	WRF25					; * 
		LDD		BUF,Z+25				; * 
		CORRECTOR1						; * 
		SBIS	PINE,RBBCP				; * 
		RJMP	WRF25					; * 
		OUT		VDATA25,BUF				; * 8                                     1151

WRF26:	SBIS	PINE,RBBCP				; * 
		RJMP	WRF26					; * 
		LDD		BUF,Z+26				; * 
		CORRECTOR1						; * 
		SBIS	PINE,RBBCP				; * 
		RJMP	WRF26					; * 
		OUT		VDATA26,BUF				; * 8                                     1159

WRF27:	SBIS	PINE,RBBCP				; * 
		RJMP	WRF27					; * 
		LDD		BUF,Z+27				; * 
		CORRECTOR1						; * 
		SBIS	PINE,RBBCP				; * 
		RJMP	WRF27					; * 
		OUT		VDATA27,BUF				; * 8                                     1167

WRF28:	SBIS	PINE,RBBCP				; * 
		RJMP	WRF28					; * 
		LDD		BUF,Z+28				; * 
		CORRECTOR1						; * 
		SBIS	PINE,RBBCP				; * 
		RJMP	WRF28					; * 
		OUT		VDATA28,BUF				; * 8                                     1175

WRF29:	SBIS	PINE,RBBCP				; * 
		RJMP	WRF29					; * 
		LDD		BUF,Z+29				; * 
		CORRECTOR1						; * 
		SBIS	PINE,RBBCP				; * 
		RJMP	WRF29					; * 
		OUT		VDATA29,BUF				; * 8                                     1183

WRF30:	SBIS	PINE,RBBCP				; * 
		RJMP	WRF30					; * 
		LDD		VDATA30,Z+30			; * 
		CORRECTOR1						; * 
		SBIS	PINE,RBBCP				; * 
		RJMP	WRF30					; * 7                                     1190

WRF31:	SBIS	PINE,RBBCP				; * 
		RJMP	WRF31					; * 
		LDD		VDATA31,Z+31			; * 
		CORRECTOR1						; * 
		SBIS	PINE,RBBCP				; * 
		RJMP	WRF31					; * 7                                     1197
	
ELBRD:	LDI		ZH,0X12					;                                         1198
		IN		ZL,TCNT1L				;                                         1199
		IJMP							;                                         1201

.ORG	0X1200

		
		
		NOP								;                                         1202
		NOP								;                                         1203
		NOP                             ;                                         1204
		NOP								;                                         1205
		NOP								;                                         1206
		NOP								;                                         1207
		NOP								;                                         1208
		NOP								;                                         1209	
		NOP								;                                         1210  
		NOP								;                                         1211
		NOP                             ;                                         1212
		NOP								;                                         1213
		NOP								;                                         1214
		NOP								;                                         1215
		NOP								;                                         1216
		NOP								;                                         1217
		NOP								;                                         1218
		NOP								;                                         1219
		NOP                             ; 	                                      1220
		NOP                             ;                                         
		NOP								;                                         
		NOP								;                                         
		NOP                             ;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP                             ; 	                                      1230
		NOP                             ;                                         
		NOP								;                                         
		NOP								;                                         
		NOP                             ;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP                             ; 	                                      1240
		NOP                             ;                                         
		NOP								;                                         
		NOP								;                                         
		NOP                             ;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP                             ; 	                                      1250
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         1260
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         1270
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         1280
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                        
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         1290
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         1300
		NOP								;                                         
		NOP								;                                        
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         1310
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		RJMP	STRTST					;                                         1317
		NOP								; 78
		NOP								; 79
		NOP								; 7A
		NOP								; 7B
		NOP								; 7C
		NOP								; 7D
		NOP								; 7E
		NOP								; 7F
		NOP								; 80
		NOP								; 81
		NOP								; 82
		NOP								; 83
		NOP								; 84
		NOP								; 85
		NOP								; 86
		NOP								; 87
		NOP								; 88
		NOP								; 89
		NOP								; 8A
		NOP								; 8B
		NOP								; 8C
		NOP								; 8D
		NOP								; 8E
		NOP								; 8F

STRTST:	IN		ZH,ADRVDATAH			; 1                                       1318
		IN		ZL,ADRVDATAL			; 1                                       1319
		LDI		BUF,0X20				; 1                                       1320
		CLR		BORDER					; 1                                       1321
		ADD		ZL,BUF					; 1 NEXT VIDEO DATA ADDRESS               1322
		ADC		ZH,BORDER				; 1                                       1323
		OUT		ADRVDATAH,ZH			; 2                                       1324
		OUT		ADRVDATAL,ZL			; 2                                       1325
		LDI		BORDER,HIGH(ATRAREA)	;                                         1326
		LDI		BUF,LOW(ATRAREA)		;                                         1327
		CP		ZL,BUF					;                                         1328
		CPC		ZH,BORDER				;                                         1329
		BRNE	EOVATST					;                                         1330 / >1331
		LDI		BUF,HIGH(VDATABEGIN)	; 1 OF POINTERS                           1331
		OUT		ADRVDATAH,BUF			; 1                                       1332
		LDI		BUF,LOW(VDATABEGIN)		; 1                                       1333
		OUT		ADRVDATAL,BUF			; 1                                       1334
		IN		BORDER,TMPBORD			; LOAD CURRENT BORDER                     1335
		NOP								; NOP                                     1336
		RJMP	COMEOV					;                                         1338
EOVATST:LDI		BORDER,HIGH(VDATABEGIN+32)	;                                     1332
		LDI		BUF,LOW(VDATABEGIN+32)		;                                     1333
		CP		ZL,BUF					;                                         1334
		CPC		ZH,BORDER				;                                         1335
		BREQ	LOWBORD					;                                         1336 / >1337
		OUT		ADRVDATAH,ZH			;                                         1337
		OUT		ADRVDATAL,ZL			;                                         1338
COMEOV:	NOP								; NOP                                     1339
		NOP								; NOP                                     1340
		IN		BORDER,TMPBORD			;                                         1341
		JMP		STRLOOP					; NEXT STRING                             1344

;********************************************* LOW BORDER **********************************************

LOWBORD:IN		BORDER,TMPBORD			; LOAD CURRENT BORDER                     1338
		LDI		BUF,0X03				; 1 INITIALISING OF                       1339
		OUT		STRING,BUF				; 1 STRING COUNTER                        1340
		LDI		BUF,0X01				; 2 INITIALISING                          1341
		OUT		SPH,BUF					; 2 OF                                    1342
		LDI		BUF,0X00				; 2 STACK		                          1343
		OUT		SPL,BUF					; 2 POINTER                               1344
		
BRDLOOP:OUT		PORTE,BORDER			;                                         1
		LDS		BUF,ETIFR				;                                         3
		BST		BUF,OCF3A				;                                         4
		BRTC	SKIP					;                                         5 / >6
		LDI		BUF,1<<OCF3A			;                                         6
		STS		ETIFR,BUF				;                                         8
		LDI		BUF,0B10000000			;                                         9
		EOR		CONTROL,BUF				;                                         10
		RJMP	COM1					;                                         12
SKIP:	RJMP	SKIP1					;                                         8
SKIP1:	RJMP	SKIP2					;                                         10
SKIP2:	RJMP	COM1					;                                         12

COM1:	LDI		BUF,0X08				;                                         13
		ADD		CONTROL,BUF				;   N = 8                                 14
		LDI		BUF,0X52				; 2 LOAD BUF WITH 0X80                    15
		OUT		TCNT1L,BUF				; 2 SET TCNT3 TO ADDRESS POINT 0X**00     16

		; ATRIBUT LOAD AND CORRECTION                                    COUNT:

ATRLP:	IN		ZH,ADRATRH				; * 1 LOAD NEXT                     1
		IN		ZL,ADRATRL				; * 1 ATRIBUT ADDRESS               2	
		LDI		BUF,(1<<SRE)			; *                                 3
		OUT		MCUCR,BUF				; * XMEM ENABLED                    4
RDATR:	SBIS	PINE,RBBCP				; - 
		RJMP	RDATR					; - 
		LD		BUF,Z					; - 
		CORRECTOR1						; -
		SBIS	PINE,RBBCP				; - 
		RJMP	RDATR					; - 7                              11
		NOP								; NOP                              12
		NOP								; NOP                              13
		NOP								; NOP                              14
		NOP								; NOP                              15
		NOP								; NOP                              16
		NOP								; NOP                              17
		
		;NOP ; CORRECTOR
		;NOP ; CORRECTOR
		;NOP ; CORRECTOR
		CLR		BORDER					; * 1 DISABLE                      18
		OUT		MCUCR,BORDER			; * 1 XMEM                         19
		ADIW	ZL,0X01					; * NEXT ADDRESS                   21
		MOV		BORDER,BUF				; *                                22
		ANDI	BORDER,0B10000000		; *                                23
		AND		BORDER,CONTROL			; * MOV		BORDER,CONTROL;        24
		BST		BORDER,7				; *                                25
		BRTC	NOTINV					; *                                26 / 27>
		MOV		BORDER,BUF				; *                                27
		BST		BORDER,5				; *                                28
		BLD		BUF,2					; *                                29
		BST		BORDER,4				; *                                30
		BLD		BUF,1					; *                                31
		BST		BORDER,3				; *                                32
		BLD		BUF,0					; *                                33
		BST		BORDER,2				; *                                34
		BLD		BUF,5					; *                                35
		BST		BORDER,1				; *                                36
		BLD		BUF,4					; *                                37
		BST		BORDER,0				; *                                38
		BLD		BUF,3					; *                                39
		OUT		ADRATRH,ZH				; * 1 SAVE NEXT                    40
		OUT		ADRATRL,ZL				; * 1 ATRIBUT ADDRESS              41		 
		RJMP	COM2					; *                                43

NOTINV:	OUT		ADRATRH,ZH				; * 1 SAVE NEXT                    28
		OUT		ADRATRL,ZL				; * 1 ATRIBUT ADDRESS              29
		LDI		BORDER,4				; * N = 4                          30
DB00:	DEC		BORDER					; ** T = 3N-1 = 11                 
		BRNE	DB00					; **                               41
		NOP								; NOP                              42
		NOP								; NOP                              43
COM2:	IN		ZH,ATRPOINTERH			; *                                44
		IN		ZL,ATRPOINTERL			; *                                45
		ST		Z+,BUF					; *                                47
		OUT		ATRPOINTERH,ZH			; *                                48
		OUT		ATRPOINTERL,ZL			; *                                49
		MOV		BUF,CONTROL				; *                                50
		ANDI	BUF,0B00001111			; *                                51
		ANDI	CONTROL,0B11110000		; *                                52
		DEC		BUF						; *                                53
		BREQ	EOC						; *                                54 / 55>
		ADD		CONTROL,BUF				; *                                55
		RJMP	ATRLP					; *  430                           57     C=57*8-2=454

EOC:	LDI		BUF,LOW(ATRCB+768)		; 1                                       471
		LDI		BORDER,HIGH(ATRCB+768)	; 1                                       472
		CP		ZL,BUF					;                                         473
		CPC		ZH,BORDER				;                                         474
		BRNE	EOAC1					;                                         475 /> 476
		LDI		BUF,LOW(ATRCB)			; 1                                       476
		OUT		ATRPOINTERL,BUF			; 1 SP                                    477
		LDI		BUF,HIGH(ATRCB)			; 1 INITIALISING                          478
		OUT		ATRPOINTERH,BUF			; 1                                       479
		LDI		BUF,LOW(ATRAREA)		; 2                                       480
		OUT		ADRATRL,BUF				; 2 ATR POINTER                           481
		LDI		BUF,HIGH(ATRAREA)		; 2 INITIALISING                          482
		OUT		ADRATRH,BUF				; 2                                       483
		RJMP	EOAC					;                                         485
EOAC1:	RJMP	EOAC2					;                                         478
EOAC2:	RJMP	EOAC3					;                                         480
EOAC3:	RJMP	EOAC4					;                                         482
EOAC4:	RJMP	EOAC5					;                                         484
EOAC5:	NOP								; NOP                                     485
EOAC:	LDI		ZH,0X14					;                                         486
		IN		ZL,TCNT1L				;                                         487
		IJMP							;                                         489

RS2:	RESET_SYNC						; ************** SYNC ****************    996
		IN		BORDER,PIND				; ******** //////// PREPARE BORDER 1      997
		CBR		BORDER,0B10000111		; ******** //////// PREPARE BORDER 2      998
		MOV		BUF,BORDER				; ******** //////// PREPARE BORDER 2      999
		ANDI	BUF,0B00111000			; ******** //////// PREPARE BORDER 3      1000
		LSL		BUF						; ******** //////// PREPARE BORDER 4      1001
		SWAP	BUF						; ******** //////// PREPARE BORDER 5      1002
		ADD		BORDER,BUF				; ******** //////// PREPARE BORDER 6      1003
		OUT		TMPBORD,BORDER			; SAVE BORDER                             1004
		LDI		BUF,30					; N = 30                                  1005
DB08:	DEC		BUF						; * T = 3N-1 = 89                                       
		BRNE	DB08					; *                                       1094
		NOP								;                                         1095
		SET_SYNC						; ************** SYNC ****************    1098

		LDI		BUF,38					; N = 38                                  1099
DB09:	DEC		BUF						; * T = 3N-1 = 113                                       
		BRNE	DB09					; *                                       1212
		NOP								;                                         1213
		NOP								;                                         1214
		OUT		PORTE,BORDER			; 1 RAY ON  ----------------------------- 1215



		IN		BUF,STRING				;                                         1216
		INC		BUF						;                                         1217
		OUT		STRING,BUF				;                                         1218
		ANDI	BUF,0B01111111			;                                         1219
		CPI		BUF,60					;                                         1220
		BREQ	FRMTST					;                                         1221/ >1222
		LDI		BUF,40					; N = 40                                  1222
DB10:	DEC		BUF						; * T = 3N-1 = 119                                       
		BRNE	DB10					; *                                       1341
		NOP								; NOP                                     1342
		RJMP	BRDLOOP					;                                         1344

FRMTST:	IN		BUF,STRING				;                                         1223
		BST		BUF,7					;                                         1224
		BRTC	STR249					;                                         1225/ >1226

EOF:	LDI		BUF,36					; N = 36                                  1226
DB11:	DEC		BUF						; * T = 3N-1 = 107                                       
		BRNE	DB11					; *                                       1333
		LDI		BUF,HIGH(ATRCB-2)		; 1 INITIALISING                          1334
		OUT		SPH,BUF					; 1                                       1335
		LDI		BUF,LOW(ATRCB-2)		; 1                                       1336
		OUT		SPL,BUF					; 1                                       1337
		LDI		BUF,0X00				;                                         1338
		OUT		STRING,BUF				;                                         1339
		POP		BUF						;                                         1341
		JMP		STRLOOP					;                                         1344


STR249:	LDI		BUF,208					; N = 208                                 1227 = 0-117
DB12:	NOP								; * NOP                               
		NOP								; * NOP                                
		DEC		BUF						; * T = 5N-1 = 1039                       
		BRNE	DB12					; *                                       922
		NOP								; NOP                                     923
		NOP								; NOP                                     924
		CLR		BUF						; CLEAR BUF                               925		
		OUT		STRING,BUF				;                                         926
		OUT		PORTE,BUF				; 1 RAY OFF ----------------------------- 927
		LDI		BUF,22					; N = 22                                  928
DB13:	DEC		BUF						; * T = 3N-1 = 65                         
		BRNE	DB13					; *                                       993
		RESET_SYNC						; ************** SYNC ****************    996
		LDI		BUF,33					; N = 33                                  997
DB14:	DEC		BUF						; * T = 3N-1 = 98                         
		BRNE	DB14					; *                                       1095
		SET_SYNC						; ************** SYNC ****************    1098
		LDI		BUF,38					; N = 38                                  1099
DB15:	DEC		BUF						; * T = 3N-1 = 113
		BRNE	DB15					; *                                       1212
		NOP								; NOP                                     1213
		IN		BORDER,TMPBORD			; 1 RAY                                   1214
		OUT		PORTE,BORDER			; 1 ON  --------------------------------- 1215
		
		LDI		BUF,30					; N = 30                                  1216
DB16:	DEC		BUF						; * T = 3N-1 = 89
		BRNE	DB16					; *                                       1305
		NOP								; NOP                                     1306

		RESET_MINT						;                                         1308
		LDI		BUF,59					; N = 59                                  1309
DB17:	DEC		BUF						; * T = 3N-1 = 176                     
		BRNE	DB17					; *                                       1485
		NOP								;                                         1486
		SET_MINT						;                                         1488 = 1344 + 144
		
		LDI		BUF,211					; N = 211                                 145
DB18:	NOP								; * NOP                               
		DEC		BUF						; * T = 4N-1 = 843                       
		BRNE	DB18					; *                                       988
KSILOOP:IN		BUF,STRING				;                                         989
		INC		BUF						;                                         990
		OUT		STRING,BUF				;                                         991
		CPI		BUF,4					;                                         992
		BREQ	LASTSIF					;                                         993 >994
		SET_SYNC						; ********** SYNC INSIDE FRAME *******    996
		LDI		BUF,33					; N = 33                                  997
DB19:	DEC		BUF						; * T = 3N-1 = 98                     
		BRNE	DB19					; *                                       1095
		RESET_SYNC						; ********** SYNC INSIDE FRAME *******    1098
		LDI		BUF,246					; N = 246                                 1099
DB20:	NOP								; *                                
		NOP								; *
		DEC		BUF						; * T = 5N-1 = 1229                       
 		BRNE	DB20					; *                                       2328
		NOP								; NOP                                     2329
		NOP								; NOP                                     2330
		RJMP	KSILOOP					;                                         2332 = 1344 + 988

LASTSIF:SET_SYNC						; ********** LAST FRAME SYNC *********    995-997
		LDI		BUF,33					; N = 33                                  998
DB21:	DEC		BUF						; * T = 3N-1 = 95                      
		BRNE	DB21					; *                                       1093
		LDI		BUF,0X20				; RESER                                   1094
		OUT		SPL,BUF					; SP                                      1095
LBLOOP:	SET_SYNC						; ********** LAST FRAME SYNC *********    1098

		LDI		BUF,80					; N = 80                                  1099
DB22:	DEC		BUF						; * T = 3N-1 = 239                      
		BRNE	DB22					; *                                       1338
		NOP								; NOP                                     1339
		NOP								; NOP                                     1340
		LDI		BUF,128					;                                         1341
		OUT		STRING,BUF				;                                         1342
		RJMP	BRDLOOP					;                                         1344


.ORG	0X1400


		NOP                             ;                                         450
		NOP								;                                         	
		NOP								;                                         
		NOP                             ;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         460
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         470
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         480
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         490
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                        
		NOP								;                                         
		NOP								;                                         500
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         510
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         520
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                          
		NOP								;                                          
		NOP								;                                          
		NOP								;                                          
		NOP								;                                         530
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         540
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         550
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                          
		NOP								;                                          
		NOP								;                                          
		NOP								;                                          
		NOP								;                                         560
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         570
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         580
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                          
		NOP								;                                          
		NOP								;                                          
		NOP								;                                          
		NOP								;                                         590
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         600
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         610
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                          
		NOP								;                                          
		NOP								;                                          
		NOP								;                                          
		NOP								;                                         620
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                          
		NOP								;                                          
		NOP								;                                          
		NOP								;                                          
		NOP								;                                         630
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                          
		NOP								;                                          
		NOP								;                                          
		NOP								;                                          
		NOP								;                                         640
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                          
		NOP								;                                          
		NOP								;                                          
		NOP								;                                          
		NOP								;                                         650
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                          
		NOP								;                                          
		NOP								;                                          
		NOP								;                                          
		NOP								;                                         660
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                          
		NOP								;                                          
		NOP								;                                          
		NOP								;                                          
		NOP								;                                         670
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                          
		NOP								;                                          
		NOP								;                                          
		NOP								;                                          
		NOP								;                                         680
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                          
		NOP								;                                          
		NOP								;                                          
		NOP								;                                          
		NOP								;                                         690
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                          
		NOP								;                                          
		NOP								;                                          
		NOP								;                                          
		NOP								;                                         700
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                          
		NOP								;                                          
		NOP								;                                          
		NOP								;                                          
		NOP								;                                         710
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                          
		NOP								;                                          
		NOP								;                                          
		NOP								;                                          
		NOP								;                                         720
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                          
		NOP								;                                          
		NOP								;                                          
		NOP								;                                          
		NOP								;                                         730
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         
		NOP								;                                         737
		SBIS	PIND,TOVCPU				;                                         738 /> 740
		JMP		F_INT					;                                         
		LDI		BUF,83					;  N = 83                                 741
DB01:	DEC		BUF						; * T = 3N-1 = 248                 
		BRNE	DB01					; *                                       989
		NOP								;                                         990	                                        
		JMP		RS2						;                                         993

;.INCLUDE "disasm_table.inc"





;*********************************************************************
;*********************************************************************
;*********************************************************************


.ORG	0XFE00
		JMP		RESET

; ////////////////////////////////////////////////////////////////////




F_INT:	CBI		PORTD,TOCPU				; ANSWER TO CPU 
		CBI		PORTC,7					; 1 RESET 
		SBI		DDRC,7					; 1 A15
		LDI		BUF,1<<XMM0				; 1 RELEASE
		STS		XMCRB,BUF				; 1 PC7	
		LDI		ZH,0X80					; 1 MODE MARKER
		LDI		ZL,0XFF					; 1 ADDRESS
		XON								; ENAMLE XMEM
		LD		BORDER,Z				; LOAD MODE MARKER
		XOFF							; DISABLE XMEM
		CPI		BORDER,0X80				; 1 IDENTIFY 
		BREQ	STORER					; 1 MODE
		JMP		LOADER					; 1


STORER:	PUSH	BUF2					; 2 ( R25 = BUF2 = VDATA30 )                      SAVE REGISTERS
		PUSH	XL						; 2 ( R26 = BUF3 )
		PUSH	XH						; 2 ( R27 = BUF )
		PUSH	YL						; 2 ( R28 = BORDER )
		PUSH	YH						; 2 ( R29 = CONTROL )
		PUSH	ZL						; 2 ( R30 = ZL ) 
		PUSH	ZH						; 2 ( R31 = ZH )
		PUSH	VDATA16					; 2 ( R16 )

		LDI		ZL,0X00					; BEGIN ADDRESS IS 0X0000 (8000)
		OUT		EEARH,ZL				; 
LPSTR1:	OUT		EEARL,ZL				; 
		XON								; ENABLE XMEM
		LD		BORDER,Z+				; READ DATA	
		XOFF							; DISABLE XMEM
		OUT		EEDR,BORDER				; 
		SBI		EECR,EEMWE				; 
		SBI		EECR,EEWE				; 
WAIWR1:	SBIC	EECR,EEWE				; 
		RJMP	WAIWR1					; 
		WDR								; 
		CPI		ZL,64					; 
		BRNE	LPSTR1					; 
		
		CBI		DDRC,7					; 1 A15 AS INPUT
		LDI		BUF,0X00				; 2 SET PC7
		STS		XMCRB,BUF				; 2 AS A15

		LDI		XH,0X40					; 3 RAM START
		LDI		XL,0X00					; 3 ADDRESS
		LDI		ZL,0X00					; 3 ROM PAGE
		LDI		ZH,0X00					; 3 BEGIN ADDRESS
		LDI		VDATA16,1<<SPMEN		; DATA FOR FILLING TEMPORARY BUFFER 

PGLOOP:	;LDI		BUF2,0X00				; 4 SET 
		;OUT		RAMPZ,BUF2				; 4 RAM PAGE 0
		
		LDI		BUF2,128				; 5 ENABLE
		OUT		MCUCR,BUF2				; 5 XMEM
FILLTB:	MOV		ZL,XL					; 5 TEMPORARY BUFFER ADDRESS
		LD		R0,X+					; 5 READ R0
		LD		R1,X+					; 5 READ R1
		STS		SPMCSR,VDATA16			; 5 
		SPM								; 5 SAVE R1:R0 TO TEMP BUFFER
		WDR								; 5
		CPI		XL,0X00					; 5 TEST FOR END OF PAGE
		BRNE	FILLTB					; 5 LOOP OF FILLING TMP BUFFER
		LDI		BUF2,0X00				; 5 DISABLE
		OUT		MCUCR,BUF2				; 5 XMEM	


		LDI		BUF2,1<<RAMPZ0			; 6 SET 
		OUT		RAMPZ,BUF2				; 6 RAM PAGE 1

		LDI		BUF2,(1<<PGERS)|(1<<SPMEN);7 
		STS		SPMCSR,BUF2				; 7 CURRENT
		SPM								; 7 
WFPGERS:LDS		BUF2,SPMCSR				; 7 PAGE 
		WDR								; 7
		SBRC	BUF2,PGERS				; 7 ERASE
		RJMP	WFPGERS					; 7 

		LDI		BUF2,(1<<PGWRT)|(1<<SPMEN);8 
		STS		SPMCSR,BUF2				; 8 
		SPM								; 8 (ZL = 0)
WFPGWRT:LDS		BUF2,SPMCSR				; 8 PAGE 
		WDR								; 8
		SBRC	BUF2,PGWRT				; 8 WRITE
		RJMP	WFPGWRT					; 8 

		INC		ZH						; NEXT PAGE
		CPI		XH,0X00					; TEST FOR END OF RAM
		BRNE	PGLOOP					; 

		LDI		BORDER,0X00				; SET 
		OUT		RAMPZ,BORDER			; RAM PAGE 0
		SBI		PORTD,TOCPU				; ANSWER TO CPU - END OF OPERATION
	
		POP		VDATA16					; 2 ( R16 )	                    	RESTORE REGISTERS
		POP		ZH						; 2 ( R31 = ZH )		
		POP		ZL						; 2 ( R30 = ZL ) 		
		POP		YH						; 2 ( R29 = CONTROL )
		POP		YL						; 2 ( R28 = BORDER )
		POP		XH						; 2 ( R27 = BUF )		
		POP		XL						; 2 ( R26 = BUF3 )		
		POP		BUF2					; 2 ( R25 = BUF2 = VDATA30 ) 
				
		JMP		RESET					; JUMP TO RESET

; ////////////////////////////////////////////////////////////////////

LOADER:	PUSH	BUF2					; 2 ( R25 = BUF2 = VDATA30 )                      SAVE REGISTERS
		PUSH	XL						; 2 ( R26 = BUF3 )
		PUSH	XH						; 2 ( R27 = BUF )
		PUSH	YL						; 2 ( R28 = BORDER )
		PUSH	YH						; 2 ( R29 = CONTROL )
		PUSH	ZL						; 2 ( R30 = ZL ) 
		PUSH	ZH						; 2 ( R31 = ZH )
		PUSH	VDATA16					; 2 ( R16 )

		LDI		ZL,0X00					; DATA STORE BEGIN ADDRESS (ZH = 0X80)
		OUT		EEARH,ZL				; OF DATA BEGIN 
		XON								; ENABLE XMEM
LPEELD:	WDR
		OUT		EEARL,ZL				; 1 EEPROM ADDRESS		
		SBI		EECR,EERE				; READ EEPROM DATA
		IN		BUF2,EEDR				; 
		ST		Z+,BUF2					; STORE DATA
		CPI		ZL,64					; TEST FOR END OF DATA
		BRNE	LPEELD					; 

		CBI		DDRC,7					; 1 A15 AS INPUT
		LDI		BUF2,0X00				; 1 SET PC7
		STS		XMCRB,BUF2				; 1 AS A15	

		LDI		BUF2,1<<RAMPZ0			; 2 SET
		OUT		RAMPZ,BUF2				; 2 PAGE 1
		LDI		ZH,0X00					; 2 FLASH DATA
		LDI		ZL,0X00					; 2 BEGIN ADDRESS
		LDI		XH,0X40					; 2 EXTERNAL
		LDI		XL,0X00					; 2 RAM BEGIN		

LRAMFIL:ELPM	BUF2,Z+					; READ DATA FROM FLASH
		WDR								; 
		ST		X+,BUF2					; SAVE DATA TO EXTERNAL RAM
		CPI		XH,0X00					; TEST FOR END OF RAM
		BRNE	LRAMFIL					; 
		XOFF

		LDI		BUF2,0X00				; SET 
		OUT		RAMPZ,BUF2				; RAM PAGE 0
		SBI		PORTD,TOCPU				; PROCESS ENDED		
		POP		VDATA16					; 2 ( R16 )	                    	RESTORE REGISTERS
		POP		ZH						; 2 ( R31 = ZH )		
		POP		ZL						; 2 ( R30 = ZL ) 		
		POP		YH						; 2 ( R29 = CONTROL )
		POP		YL						; 2 ( R28 = BORDER )
		POP		XH						; 2 ( R27 = BUF )		
		POP		XL						; 2 ( R26 = BUF3 )		
		POP		BUF2					; 2 ( R25 = BUF2 = VDATA30 ) 
		JMP		RESET					; JUMP TO RESET













