;********************** MACRO DEFINITIONS ************************

.MACRO SET_MINT
        SBI		PORTD,MINT
.ENDMACRO

.MACRO RESET_MINT
        CBI		PORTD,MINT
.ENDMACRO

.MACRO SET_SYNC
        LDI		BUF,1<<SYNC
		STS		PORTF,BUF
.ENDMACRO

.MACRO RESET_SYNC
        LDI		BUF,0X00
		STS		PORTF,BUF
.ENDMACRO

.MACRO CORRECTOR1
        ;NOP
.ENDMACRO


.MACRO CORRECTOR3
        NOP
		nop
		nop
.ENDMACRO

.MACRO CORRECTOR7
        NOP
		NOP
		NOP
		NOP
		NOP
		NOP
		NOP
.ENDMACRO

.MACRO CORRECTOR8
        NOP
		NOP
		NOP
		NOP
		NOP
		NOP
		NOP
		NOP
.ENDMACRO

.MACRO XON
        LDI		BUF,128
		OUT		MCUCR,BUF
.ENDMACRO

.MACRO XOFF
        LDI		BUF,0
		OUT		MCUCR,BUF
.ENDMACRO

.MACRO PAUSE1
        ;NOP
		;NOP
		;NOP
.ENDMACRO

.MACRO PAUSE2
        ;NOP
		;NOP
		;NOP
.ENDMACRO

.MACRO VIDEOSTRING									; VDATA IS ALLREADY PREPARED IN VDATA0
		; BUF CONTAINS NEXT ATRIBUT TO SEND, VIDEO DATA IS PREPARED IN VDATA0 - VDATA31
		OUT		PORTB,VDATA0						; SET BIT 7
		OUT		PORTE,BUF							; SET ATRIBUT
		LSL		VDATA0								; PREPARE BIT 6
		OUT		PORTB,VDATA0						; SET BIT 6
		NOP											;  
		LSL		VDATA0								; PREPARE BIT 5
		OUT		PORTB,VDATA0						; SET BIT 5
		NOP											;  
		LSL		VDATA0								; PREPARE BIT 4
		OUT		PORTB,VDATA0						; SET BIT 4
		NOP											;  
		LSL		VDATA0								; PREPARE BIT 3
		OUT		PORTB,VDATA0						; SET BIT 3
		NOP											;  
		LSL		VDATA0								; PREPARE BIT 2
		OUT		PORTB,VDATA0						; SET BIT 2
		NOP											;  
		LSL		VDATA0								; PREPARE BIT 1
		OUT		PORTB,VDATA0						; SET BIT 1
		NOP											; 
		LSL		VDATA0								; PREPARE BIT 0
		OUT		PORTB,VDATA0						; SET BIT 0
		POP		BUF									; PREPARE NEXT ATRIBUT
		
		OUT		PORTB,VDATA1						; SET BIT 7
		OUT		PORTE,BUF							; SET ATRIBUT
		LSL		VDATA1								; PREPARE BIT 6
		OUT		PORTB,VDATA1						; SET BIT 6
								IN		ZH,ADRVDATAH;   
		LSL		VDATA1								; PREPARE BIT 5
		OUT		PORTB,VDATA1						; SET BIT 5
								IN		ZL,ADRVDATAL;  
		LSL		VDATA1								; PREPARE BIT 4
		OUT		PORTB,VDATA1						; SET BIT 4
								MOV		BORDER,ZL	; 
		LSL		VDATA1								; PREPARE BIT 3
		OUT		PORTB,VDATA1						; SET BIT 3
								BST		ZH,2		; 
		LSL		VDATA1								; PREPARE BIT 2
		OUT		PORTB,VDATA1						; SET BIT 2
								BLD		ZL,7		; 
		LSL		VDATA1								; PREPARE BIT 1
		OUT		PORTB,VDATA1						; SET BIT 1
								BST		ZH,1		; 
		LSL		VDATA1								; PREPARE BIT 0
		OUT		PORTB,VDATA1						; SET BIT 0
		POP		BUF									; PREPARE NEXT ATRIBUT
			
		OUT		PORTB,VDATA2						; SET BIT 7
		OUT		PORTE,BUF							; SET ATRIBUT
		LSL		VDATA2								; PREPARE BIT 6
		OUT		PORTB,VDATA2						; SET BIT 6
								BLD		ZL,6		; 
		LSL		VDATA2								; PREPARE BIT 5
		OUT		PORTB,VDATA2						; SET BIT 5
								BST		ZH,0		; 
		LSL		VDATA2								; PREPARE BIT 4
		OUT		PORTB,VDATA2						; SET BIT 4
								BLD		ZL,5		; 
		LSL		VDATA2								; PREPARE BIT 3
		OUT		PORTB,VDATA2						; SET BIT 3
								BST		BORDER,7	; 
		LSL		VDATA2								; PREPARE BIT 2
		OUT		PORTB,VDATA2						; SET BIT 2
								BLD		ZH,2		; 
		LSL		VDATA2								; PREPARE BIT 1
		OUT		PORTB,VDATA2						; SET BIT 1
								BST		BORDER,6	; 
		LSL		VDATA2								; PREPARE BIT 0
		OUT		PORTB,VDATA2						; SET BIT 0
		POP		BUF									; PREPARE NEXT ATRIBUT
		
		OUT		PORTB,VDATA3						; SET BIT 7
		OUT		PORTE,BUF							; SET ATRIBUT
		LSL		VDATA3								; PREPARE BIT 6
		OUT		PORTB,VDATA3						; SET BIT 6
								BLD		ZH,1		; 
		LSL		VDATA3								; PREPARE BIT 5
		OUT		PORTB,VDATA3						; SET BIT 5
								BST		BORDER,5	; 
		LSL		VDATA3								; PREPARE BIT 4
		OUT		PORTB,VDATA3						; SET BIT 4
								BLD		ZH,0		; 
		LSL		VDATA3								; PREPARE BIT 3
		OUT		PORTB,VDATA3						; SET BIT 3
		NOP											;  
		LSL		VDATA3								; PREPARE BIT 2
		OUT		PORTB,VDATA3						; SET BIT 2
		NOP											;  
		LSL		VDATA3								; PREPARE BIT 1
		OUT		PORTB,VDATA3						; SET BIT 1
		NOP											; 
		LSL		VDATA3								; PREPARE BIT 0
		OUT		PORTB,VDATA3						; SET BIT 0
		POP		BUF									; PREPARE NEXT ATRIBUT

		OUT		PORTB,VDATA4						; SET BIT 7
		OUT		PORTE,BUF							; SET ATRIBUT
		LSL		VDATA4								; PREPARE BIT 6
		OUT		PORTB,VDATA4						; SET BIT 6
								LDI	BORDER,0X7F		; 
		LSL		VDATA4								; PREPARE BIT 5
		OUT		PORTB,VDATA4						; SET BIT 5
								OUT	TCNT1H,BORDER	; 
		LSL		VDATA4								; PREPARE BIT 4
		OUT		PORTB,VDATA4						; SET BIT 4
								LDI	BORDER,0X0A		; 
		LSL		VDATA4								; PREPARE BIT 3
		OUT		PORTB,VDATA4						; SET BIT 3
								OUT	TCNT1L,BORDER	; 
		LSL		VDATA4								; PREPARE BIT 2
		OUT		PORTB,VDATA4						; SET BIT 2
		NOP											;  
		LSL		VDATA4								; PREPARE BIT 1
		OUT		PORTB,VDATA4						; SET BIT 1
								WDR  				; 
		LSL		VDATA4								; PREPARE BIT 0
		OUT		PORTB,VDATA4						; SET BIT 0
		POP		BUF									; PREPARE NEXT ATRIBUT
		
		OUT		PORTB,VDATA5						; SET BIT 7
		OUT		PORTE,BUF							; SET ATRIBUT
		LSL		VDATA5								; PREPARE BIT 6
		OUT		PORTB,VDATA5						; SET BIT 6
		NOP											;  
		LSL		VDATA5								; PREPARE BIT 5
		OUT		PORTB,VDATA5						; SET BIT 5
		NOP											;  
		LSL		VDATA5								; PREPARE BIT 4
		OUT		PORTB,VDATA5						; SET BIT 4
		NOP											;  
		LSL		VDATA5								; PREPARE BIT 3
		OUT		PORTB,VDATA5						; SET BIT 3
		NOP											;  
		LSL		VDATA5								; PREPARE BIT 2
		OUT		PORTB,VDATA5						; SET BIT 2
		NOP											;  
		LSL		VDATA5								; PREPARE BIT 1
		OUT		PORTB,VDATA5						; SET BIT 1
		NOP											;  
		LSL		VDATA5								; PREPARE BIT 0
		OUT		PORTB,VDATA5						; SET BIT 0
		POP		BUF									; PREPARE NEXT ATRIBUT
			
		OUT		PORTB,VDATA6						; SET BIT 7
		OUT		PORTE,BUF							; SET ATRIBUT
		LSL		VDATA6								; PREPARE BIT 6
		OUT		PORTB,VDATA6						; SET BIT 6
								IN	BORDER,PIND		; ******** //////// PREPARE BORDER 1 
		LSL		VDATA6								; PREPARE BIT 5
		OUT		PORTB,VDATA6						; SET BIT 5
								CBR	BORDER,0B10000111; ******** //////// PREPARE BORDER 2 
		LSL		VDATA6								; PREPARE BIT 4
		OUT		PORTB,VDATA6						; SET BIT 4
								MOV	VDATA5,BORDER	; ******** //////// PREPARE BORDER 3
		LSL		VDATA6								; PREPARE BIT 3
		OUT		PORTB,VDATA6						; SET BIT 3
								LDI	BUF,0B00111000	; ******** //////// PREPARE BORDER 4
		LSL		VDATA6								; PREPARE BIT 2
		OUT		PORTB,VDATA6						; SET BIT 2
								AND VDATA5,BUF		; ******** //////// PREPARE BORDER 5
		LSL		VDATA6								; PREPARE BIT 1
		OUT		PORTB,VDATA6						; SET BIT 1
								LSL	VDATA5			; ******** //////// PREPARE BORDER 6
		LSL		VDATA6								; PREPARE BIT 0
		OUT		PORTB,VDATA6						; SET BIT 0
		POP		BUF									; PREPARE NEXT ATRIBUT
		
		OUT		PORTB,VDATA7						; SET BIT 7
		OUT		PORTE,BUF							; SET ATRIBUT
		LSL		VDATA7								; PREPARE BIT 6
		OUT		PORTB,VDATA7						; SET BIT 6
								SWAP VDATA5			; ******** //////// PREPARE BORDER 7
		LSL		VDATA7								; PREPARE BIT 5
		OUT		PORTB,VDATA7						; SET BIT 5
								ADD	BORDER,VDATA5	; ******** //////// PREPARE BORDER 8
		LSL		VDATA7								; PREPARE BIT 4
		OUT		PORTB,VDATA7						; SET BIT 4
								OUT	TMPBORD,BORDER	; SAVE	BORDER
		LSL		VDATA7								; PREPARE BIT 3
		OUT		PORTB,VDATA7						; SET BIT 3
		NOP											;  
		LSL		VDATA7								; PREPARE BIT 2
		OUT		PORTB,VDATA7						; SET BIT 2
		NOP											;  
		LSL		VDATA7								; PREPARE BIT 1
		OUT		PORTB,VDATA7						; SET BIT 1
		NOP											;  
		LSL		VDATA7								; PREPARE BIT 0
		OUT		PORTB,VDATA7						; SET BIT 0
		POP		BUF									; PREPARE NEXT ATRIBUT
		
		OUT		PORTB,VDATA8						; SET BIT 7
		OUT		PORTE,BUF							; SET ATRIBUT
		LSL		VDATA8								; PREPARE BIT 6
		OUT		PORTB,VDATA8						; SET BIT 6
		NOP											;  
		LSL		VDATA8								; PREPARE BIT 5
		OUT		PORTB,VDATA8						; SET BIT 5
		NOP											;  
		LSL		VDATA8								; PREPARE BIT 4
		OUT		PORTB,VDATA8						; SET BIT 4
		NOP											;  
		LSL		VDATA8								; PREPARE BIT 3
		OUT		PORTB,VDATA8						; SET BIT 3
		NOP											;  
		LSL		VDATA8								; PREPARE BIT 2
		OUT		PORTB,VDATA8						; SET BIT 2
		NOP											;  
		LSL		VDATA8								; PREPARE BIT 1
		OUT		PORTB,VDATA8						; SET BIT 1
		NOP											;  
		LSL		VDATA8								; PREPARE BIT 0
		OUT		PORTB,VDATA8						; SET BIT 0
		POP		BUF									; PREPARE NEXT ATRIBUT
		
		OUT		PORTB,VDATA9						; SET BIT 7
		OUT		PORTE,BUF							; SET ATRIBUT
		LSL		VDATA9								; PREPARE BIT 6
		OUT		PORTB,VDATA9						; SET BIT 6
		NOP											;  
		LSL		VDATA9								; PREPARE BIT 5
		OUT		PORTB,VDATA9						; SET BIT 5
		NOP											;  
		LSL		VDATA9								; PREPARE BIT 4
		OUT		PORTB,VDATA9						; SET BIT 4
		NOP											;  
		LSL		VDATA9								; PREPARE BIT 3
		OUT		PORTB,VDATA9						; SET BIT 3
		NOP											;  
		LSL		VDATA9								; PREPARE BIT 2
		OUT		PORTB,VDATA9						; SET BIT 2
		NOP											;  
		LSL		VDATA9								; PREPARE BIT 1
		OUT		PORTB,VDATA9						; SET BIT 1
		NOP											;  
		LSL		VDATA9								; PREPARE BIT 0
		OUT		PORTB,VDATA9						; SET BIT 0
		POP		BUF									; PREPARE NEXT ATRIBUT
			
		OUT		PORTB,VDATA10						; SET BIT 7
		OUT		PORTE,BUF							; SET ATRIBUT
		LSL		VDATA10								; PREPARE BIT 6
		OUT		PORTB,VDATA10						; SET BIT 6
		NOP											;  
		LSL		VDATA10								; PREPARE BIT 5
		OUT		PORTB,VDATA10						; SET BIT 5
		NOP											;  
		LSL		VDATA10								; PREPARE BIT 4
		OUT		PORTB,VDATA10						; SET BIT 4
		NOP											;  
		LSL		VDATA10								; PREPARE BIT 3
		OUT		PORTB,VDATA10						; SET BIT 3
		NOP											;  
		LSL		VDATA10								; PREPARE BIT 2
		OUT		PORTB,VDATA10						; SET BIT 2
		NOP											;  
		LSL		VDATA10								; PREPARE BIT 1
		OUT		PORTB,VDATA10						; SET BIT 1
		NOP											;  
		LSL		VDATA10								; PREPARE BIT 0
		OUT		PORTB,VDATA10						; SET BIT 0
		POP		BUF									; PREPARE NEXT ATRIBUT
		
		OUT		PORTB,VDATA11						; SET BIT 7
		OUT		PORTE,BUF							; SET ATRIBUT
		LSL		VDATA11								; PREPARE BIT 6
		OUT		PORTB,VDATA11						; SET BIT 6
		NOP											;  
		LSL		VDATA11								; PREPARE BIT 5
		OUT		PORTB,VDATA11						; SET BIT 5
		NOP											;  
		LSL		VDATA11								; PREPARE BIT 4
		OUT		PORTB,VDATA11						; SET BIT 4
		NOP											;  
		LSL		VDATA11								; PREPARE BIT 3
		OUT		PORTB,VDATA11						; SET BIT 3
		NOP											;  
		LSL		VDATA11								; PREPARE BIT 2
		OUT		PORTB,VDATA11						; SET BIT 2
		NOP											;  
		LSL		VDATA11								; PREPARE BIT 1
		OUT		PORTB,VDATA11						; SET BIT 1
		NOP											;  
		LSL		VDATA11								; PREPARE BIT 0
		OUT		PORTB,VDATA11						; SET BIT 0
		POP		BUF									; PREPARE NEXT ATRIBUT

		OUT		PORTB,VDATA12						; SET BIT 7
		OUT		PORTE,BUF							; SET ATRIBUT
		LSL		VDATA12								; PREPARE BIT 6
		OUT		PORTB,VDATA12						; SET BIT 6
		NOP											;  
		LSL		VDATA12								; PREPARE BIT 5
		OUT		PORTB,VDATA12						; SET BIT 5
		NOP											;  
		LSL		VDATA12								; PREPARE BIT 4
		OUT		PORTB,VDATA12						; SET BIT 4
		NOP											;  
		LSL		VDATA12								; PREPARE BIT 3
		OUT		PORTB,VDATA12						; SET BIT 3
		NOP											;  
		LSL		VDATA12								; PREPARE BIT 2
		OUT		PORTB,VDATA12						; SET BIT 2
		NOP											;  
		LSL		VDATA12								; PREPARE BIT 1
		OUT		PORTB,VDATA12						; SET BIT 1
		NOP											;  
		LSL		VDATA12								; PREPARE BIT 0
		OUT		PORTB,VDATA12						; SET BIT 0
		POP		BUF									; PREPARE NEXT ATRIBUT
		
		OUT		PORTB,VDATA13						; SET BIT 7
		OUT		PORTE,BUF							; SET ATRIBUT
		LSL		VDATA13								; PREPARE BIT 6
		OUT		PORTB,VDATA13						; SET BIT 6
		NOP											;  
		LSL		VDATA13								; PREPARE BIT 5
		OUT		PORTB,VDATA13						; SET BIT 5
		NOP											;  
		LSL		VDATA13								; PREPARE BIT 4
		OUT		PORTB,VDATA13						; SET BIT 4
		NOP											;  
		LSL		VDATA13								; PREPARE BIT 3
		OUT		PORTB,VDATA13						; SET BIT 3
		NOP											;  
		LSL		VDATA13								; PREPARE BIT 2
		OUT		PORTB,VDATA13						; SET BIT 2
		NOP											;  
		LSL		VDATA13								; PREPARE BIT 1
		OUT		PORTB,VDATA13						; SET BIT 1
		NOP											;  
		LSL		VDATA13								; PREPARE BIT 0
		OUT		PORTB,VDATA13						; SET BIT 0
		POP		BUF									; PREPARE NEXT ATRIBUT
			
		OUT		PORTB,VDATA14						; SET BIT 7
		OUT		PORTE,BUF							; SET ATRIBUT
		LSL		VDATA14								; PREPARE BIT 6
		OUT		PORTB,VDATA14						; SET BIT 6
		NOP											;  
		LSL		VDATA14								; PREPARE BIT 5
		OUT		PORTB,VDATA14						; SET BIT 5
		NOP											;  
		LSL		VDATA14								; PREPARE BIT 4
		OUT		PORTB,VDATA14						; SET BIT 4
		NOP											;  
		LSL		VDATA14								; PREPARE BIT 3
		OUT		PORTB,VDATA14						; SET BIT 3
		NOP											;  
		LSL		VDATA14								; PREPARE BIT 2
		OUT		PORTB,VDATA14						; SET BIT 2
		NOP											;  
		LSL		VDATA14								; PREPARE BIT 1
		OUT		PORTB,VDATA14						; SET BIT 1
		NOP											;  
		LSL		VDATA14								; PREPARE BIT 0
		OUT		PORTB,VDATA14						; SET BIT 0
		POP		BUF									; PREPARE NEXT ATRIBUT
		
		OUT		PORTB,VDATA15						; SET BIT 7
		OUT		PORTE,BUF							; SET ATRIBUT
		LSL		VDATA15								; PREPARE BIT 6
		OUT		PORTB,VDATA15						; SET BIT 6
		NOP											;  
		LSL		VDATA15								; PREPARE BIT 5
		OUT		PORTB,VDATA15						; SET BIT 5
		NOP											;  
		LSL		VDATA15								; PREPARE BIT 4
		OUT		PORTB,VDATA15						; SET BIT 4
		NOP											;  
		LSL		VDATA15								; PREPARE BIT 3
		OUT		PORTB,VDATA15						; SET BIT 3
		NOP											;  
		LSL		VDATA15								; PREPARE BIT 2
		OUT		PORTB,VDATA15						; SET BIT 2
		NOP											;  
		LSL		VDATA15								; PREPARE BIT 1
		OUT		PORTB,VDATA15						; SET BIT 1
		NOP											;  
		LSL		VDATA15								; PREPARE BIT 0
		OUT		PORTB,VDATA15						; SET BIT 0
		POP		BUF									; PREPARE NEXT ATRIBUT

		OUT		PORTB,VDATA16						; SET BIT 7
		OUT		PORTE,BUF							; SET ATRIBUT
		LSL		VDATA16								; PREPARE BIT 6
		OUT		PORTB,VDATA16						; SET BIT 6
		NOP											;  
		LSL		VDATA16								; PREPARE BIT 5
		OUT		PORTB,VDATA16						; SET BIT 5
		NOP											;  
		LSL		VDATA16								; PREPARE BIT 4
		OUT		PORTB,VDATA16						; SET BIT 4
		NOP											;  
		LSL		VDATA16								; PREPARE BIT 3
		OUT		PORTB,VDATA16						; SET BIT 3
		NOP											;  
		LSL		VDATA16								; PREPARE BIT 2
		OUT		PORTB,VDATA16						; SET BIT 2
		NOP											;  
		LSL		VDATA16								; PREPARE BIT 1
		OUT		PORTB,VDATA16						; SET BIT 1
		NOP											;  
		LSL		VDATA16								; PREPARE BIT 0
		OUT		PORTB,VDATA16						; SET BIT 0
		POP		BUF									; PREPARE NEXT ATRIBUT
		
		OUT		PORTB,VDATA17						; SET BIT 7
		OUT		PORTE,BUF							; SET ATRIBUT
		LSL		VDATA17								; PREPARE BIT 6
		OUT		PORTB,VDATA17						; SET BIT 6
		NOP											;  
		LSL		VDATA17								; PREPARE BIT 5
		OUT		PORTB,VDATA17						; SET BIT 5
		NOP											;  
		LSL		VDATA17								; PREPARE BIT 4
		OUT		PORTB,VDATA17						; SET BIT 4
		NOP											;  
		LSL		VDATA17								; PREPARE BIT 3
		OUT		PORTB,VDATA17						; SET BIT 3
		NOP											;  
		LSL		VDATA17								; PREPARE BIT 2
		OUT		PORTB,VDATA17						; SET BIT 2
		NOP											;  
		LSL		VDATA17								; PREPARE BIT 1
		OUT		PORTB,VDATA17						; SET BIT 1
		NOP											;  
		LSL		VDATA17								; PREPARE BIT 0
		OUT		PORTB,VDATA17						; SET BIT 0
		POP		BUF									; PREPARE NEXT ATRIBUT
			
		OUT		PORTB,VDATA18						; SET BIT 7
		OUT		PORTE,BUF							; SET ATRIBUT
		LSL		VDATA18								; PREPARE BIT 6
		OUT		PORTB,VDATA18						; SET BIT 6
		NOP											;  
		LSL		VDATA18								; PREPARE BIT 5
		OUT		PORTB,VDATA18						; SET BIT 5
		NOP											;  
		LSL		VDATA18								; PREPARE BIT 4
		OUT		PORTB,VDATA18						; SET BIT 4
		NOP											;  
		LSL		VDATA18								; PREPARE BIT 3
		OUT		PORTB,VDATA18						; SET BIT 3
		NOP											;  
		LSL		VDATA18								; PREPARE BIT 2
		OUT		PORTB,VDATA18						; SET BIT 2
		NOP											;  
		LSL		VDATA18								; PREPARE BIT 1
		OUT		PORTB,VDATA18						; SET BIT 1
		NOP											;  
		LSL		VDATA18								; PREPARE BIT 0
		OUT		PORTB,VDATA18						; SET BIT 0
		POP		BUF									; PREPARE NEXT ATRIBUT
		
		OUT		PORTB,VDATA19						; SET BIT 7
		OUT		PORTE,BUF							; SET ATRIBUT
		LSL		VDATA19								; PREPARE BIT 6
		OUT		PORTB,VDATA19						; SET BIT 6
		NOP											;  
		LSL		VDATA19								; PREPARE BIT 5
		OUT		PORTB,VDATA19						; SET BIT 5
		NOP											;  
		LSL		VDATA19								; PREPARE BIT 4
		OUT		PORTB,VDATA19						; SET BIT 4
		NOP											;  
		LSL		VDATA19								; PREPARE BIT 3
		OUT		PORTB,VDATA19						; SET BIT 3
		NOP											;  
		LSL		VDATA19								; PREPARE BIT 2
		OUT		PORTB,VDATA19						; SET BIT 2
		NOP											;  
		LSL		VDATA19								; PREPARE BIT 1
		OUT		PORTB,VDATA19						; SET BIT 1
		NOP											;  
		LSL		VDATA19								; PREPARE BIT 0
		OUT		PORTB,VDATA19						; SET BIT 0
		POP		BUF									; PREPARE NEXT ATRIBUT

		OUT		PORTB,VDATA20						; SET BIT 7
		OUT		PORTE,BUF							; SET ATRIBUT
		LSL		VDATA20								; PREPARE BIT 6
		OUT		PORTB,VDATA20						; SET BIT 6
		NOP											;  
		LSL		VDATA20								; PREPARE BIT 5
		OUT		PORTB,VDATA20						; SET BIT 5
		NOP											;  
		LSL		VDATA20								; PREPARE BIT 4
		OUT		PORTB,VDATA20						; SET BIT 4
		NOP											;  
		LSL		VDATA20								; PREPARE BIT 3
		OUT		PORTB,VDATA20						; SET BIT 3
		NOP											;  
		LSL		VDATA20								; PREPARE BIT 2
		OUT		PORTB,VDATA20						; SET BIT 2
		NOP											;  
		LSL		VDATA20								; PREPARE BIT 1
		OUT		PORTB,VDATA20						; SET BIT 1
		NOP											;  
		LSL		VDATA20								; PREPARE BIT 0
		OUT		PORTB,VDATA20						; SET BIT 0
		POP		BUF									; PREPARE NEXT ATRIBUT
		
		OUT		PORTB,VDATA21						; SET BIT 7
		OUT		PORTE,BUF							; SET ATRIBUT
		LSL		VDATA21								; PREPARE BIT 6
		OUT		PORTB,VDATA21						; SET BIT 6
		NOP											;  
		LSL		VDATA21								; PREPARE BIT 5
		OUT		PORTB,VDATA21						; SET BIT 5
		NOP											;  
		LSL		VDATA21								; PREPARE BIT 4
		OUT		PORTB,VDATA21						; SET BIT 4
		NOP											;  
		LSL		VDATA21								; PREPARE BIT 3
		OUT		PORTB,VDATA21						; SET BIT 3
		NOP											;  
		LSL		VDATA21								; PREPARE BIT 2
		OUT		PORTB,VDATA21						; SET BIT 2
		NOP											;  
		LSL		VDATA21								; PREPARE BIT 1
		OUT		PORTB,VDATA21						; SET BIT 1
		NOP											;  
		LSL		VDATA21								; PREPARE BIT 0
		OUT		PORTB,VDATA21						; SET BIT 0
		POP		BUF									; PREPARE NEXT ATRIBUT
			
		OUT		PORTB,VDATA22						; SET BIT 7
		OUT		PORTE,BUF							; SET ATRIBUT
		LSL		VDATA22								; PREPARE BIT 6
		OUT		PORTB,VDATA22						; SET BIT 6
		NOP											;  
		LSL		VDATA22								; PREPARE BIT 5
		OUT		PORTB,VDATA22						; SET BIT 5
		NOP											;  
		LSL		VDATA22								; PREPARE BIT 4
		OUT		PORTB,VDATA22						; SET BIT 4
		NOP											;  
		LSL		VDATA22								; PREPARE BIT 3
		OUT		PORTB,VDATA22						; SET BIT 3
		NOP											;  
		LSL		VDATA22								; PREPARE BIT 2
		OUT		PORTB,VDATA22						; SET BIT 2
		NOP											;  
		LSL		VDATA22								; PREPARE BIT 1
		OUT		PORTB,VDATA22						; SET BIT 1
		NOP											;  
		LSL		VDATA22								; PREPARE BIT 0
		OUT		PORTB,VDATA22						; SET BIT 0
		POP		BUF									; PREPARE NEXT ATRIBUT
		
		OUT		PORTB,VDATA23						; SET BIT 7
		OUT		PORTE,BUF							; SET ATRIBUT
		LSL		VDATA23								; PREPARE BIT 6
		OUT		PORTB,VDATA23						; SET BIT 6
		NOP											;  
		LSL		VDATA23								; PREPARE BIT 5
		OUT		PORTB,VDATA23						; SET BIT 5
		NOP											;  
		LSL		VDATA23								; PREPARE BIT 4
		OUT		PORTB,VDATA23						; SET BIT 4
		NOP											;  
		LSL		VDATA23								; PREPARE BIT 3
		OUT		PORTB,VDATA23						; SET BIT 3
		NOP											;  
		LSL		VDATA23								; PREPARE BIT 2
		OUT		PORTB,VDATA23						; SET BIT 2
								LDI		VDATA22,0X9F; 
		LSL		VDATA23								; PREPARE BIT 1
		OUT		PORTB,VDATA23						; SET BIT 1
								LDI		VDATA20,0X00; 
		LSL		VDATA23								; PREPARE BIT 0
		OUT		PORTB,VDATA23						; SET BIT 0
		POP		BUF									; PREPARE NEXT ATRIBUT
		
		OUT		PORTB,VDATA24						; SET BIT 7
		OUT		PORTE,BUF							; SET ATRIBUT
		LSL		VDATA24								; PREPARE BIT 6
		OUT		PORTB,VDATA24						; SET BIT 6
								LDI		VDATA21,1<<SYNC; 
		LSL		VDATA24								; PREPARE BIT 5
		OUT		PORTB,VDATA24						; SET BIT 5
								MOV		VDATA18,ZL	;
		LSL		VDATA24								; PREPARE BIT 4
		OUT		PORTB,VDATA24						; SET BIT 4
								MOV		VDATA19,ZH	;   
		LSL		VDATA24								; PREPARE BIT 3
		OUT		PORTB,VDATA24						; SET BIT 3
								IN		ZL,ADRVDATAL; 
		LSL		VDATA24								; PREPARE BIT 2
		OUT		PORTB,VDATA24						; SET BIT 2
								LDI		VDATA16,0XFF; 
		LSL		VDATA24								; PREPARE BIT 1
		OUT		PORTB,VDATA24						; SET BIT 1
		IN		VDATA0,VDATA25						; PREPARE VDATA25  
		LSL		VDATA24								; PREPARE BIT 0
		OUT		PORTB,VDATA24						; SET BIT 0
		POP		BUF									; PREPARE NEXT ATRIBUT
		
		OUT		PORTB,VDATA0						; SET BIT 7
		OUT		PORTE,BUF							; SET ATRIBUT
		LSL		VDATA0								; PREPARE BIT 6
		OUT		PORTB,VDATA0						; SET BIT 6
		LSL		VDATA0								; PREPARE BIT 5
								TST		ZL			; 
		OUT		PORTB,VDATA0						; SET BIT 5
								IN		BORDER,SREG	; 
		LSL		VDATA0								; PREPARE BIT 4
		OUT		PORTB,VDATA0						; SET BIT 4
								BST		BORDER,1	; 
		LSL		VDATA0								; PREPARE BIT 3
		OUT		PORTB,VDATA0						; SET BIT 3
								BLD		VDATA16,5	; 
		LSL		VDATA0								; PREPARE BIT 2
		OUT		PORTB,VDATA0						; SET BIT 2
								COM		VDATA16		; 
		LSL		VDATA0								; PREPARE BIT 1
		OUT		PORTB,VDATA0						; SET BIT 1
		IN		VDATA1,VDATA26						; PREPARE VDATA26  
		LSL		VDATA0								; PREPARE BIT 0
		OUT		PORTB,VDATA0						; SET BIT 0
		POP		BUF									; PREPARE NEXT ATRIBUT
			
		OUT		PORTB,VDATA1						; SET BIT 7
		OUT		PORTE,BUF							; SET ATRIBUT
		LSL		VDATA1								; PREPARE BIT 6
		OUT		PORTB,VDATA1						; SET BIT 6
								LDI		BORDER,0X00	; 
		LSL		VDATA1								; PREPARE BIT 5
		OUT		PORTB,VDATA1						; SET BIT 5
		NOP											; 
		LSL		VDATA1								; PREPARE BIT 4
		OUT		PORTB,VDATA1						; SET BIT 4
		NOP											; 
		LSL		VDATA1								; PREPARE BIT 3
		OUT		PORTB,VDATA1						; SET BIT 3
		NOP											; 
		LSL		VDATA1								; PREPARE BIT 2
		OUT		PORTB,VDATA1						; SET BIT 2
		NOP											; 
		LSL		VDATA1								; PREPARE BIT 1
		OUT		PORTB,VDATA1						; SET BIT 1
		IN		VDATA0,VDATA27						; PREPARE VDATA27  
		LSL		VDATA1								; PREPARE BIT 0
		OUT		PORTB,VDATA1						; SET BIT 0
		POP		BUF									; PREPARE NEXT ATRIBUT
		
		OUT		PORTB,VDATA0						; SET BIT 7
		OUT		PORTE,BUF							; SET ATRIBUT
		LSL		VDATA0								; PREPARE BIT 6
		OUT		PORTB,VDATA0						; SET BIT 6
								IN ZL,SPL			; 
		LSL		VDATA0								; PREPARE BIT 5
		OUT		PORTB,VDATA0						; SET BIT 5
								IN ZH,SPH			; 
		LSL		VDATA0								; PREPARE BIT 4
		OUT		PORTB,VDATA0						; SET BIT 4
								SUB		ZL,VDATA16	; 
		ROL		VDATA0								; PREPARE BIT 3
		OUT		PORTB,VDATA0						; SET BIT 3
								BST		VDATA0,0	; 
		LSL		VDATA0								; PREPARE BIT 2
		OUT		PORTB,VDATA0						; SET BIT 2
								BLD		BORDER,0	; 
		LSL		VDATA0								; PREPARE BIT 1
		OUT		PORTB,VDATA0						; SET BIT 1
		IN		VDATA1,VDATA28						; PREPARE VDATA28  
		LSL		VDATA0								; PREPARE BIT 0
		OUT		PORTB,VDATA0						; SET BIT 0
		POP		BUF									; PREPARE NEXT ATRIBUT

		OUT		PORTB,VDATA1						; SET BIT 7
		OUT		PORTE,BUF							; SET ATRIBUT
		LSL		VDATA1								; PREPARE BIT 6
		OUT		PORTB,VDATA1						; SET BIT 6
								SUB		ZH,BORDER	; 
		LSL		VDATA1								; PREPARE BIT 5
		OUT		PORTB,VDATA1						; SET BIT 5
								LDI		VDATA16,0X04; 
		LSL		VDATA1								; PREPARE BIT 4
		OUT		PORTB,VDATA1						; SET BIT 4
								LDI		BORDER,0X00	; 
		LSL		VDATA1								; PREPARE BIT 3
		OUT		PORTB,VDATA1						; SET BIT 3
								ADD		ZL,VDATA16	;  
		ROL		VDATA1								; PREPARE BIT 2
		OUT		PORTB,VDATA1						; SET BIT 2
								BST		VDATA1,0	; 
		LSL		VDATA1								; PREPARE BIT 1
		OUT		PORTB,VDATA1						; SET BIT 1
		IN		VDATA0,VDATA29						; PREPARE VDATA29  
		LSL		VDATA1								; PREPARE BIT 0
		OUT		PORTB,VDATA1						; SET BIT 0
		POP		BUF									; PREPARE NEXT ATRIBUT
		
		OUT		PORTB,VDATA0						; SET BIT 7
		OUT		PORTE,BUF							; SET ATRIBUT
		LSL		VDATA0								; PREPARE BIT 6
		OUT		PORTB,VDATA0						; SET BIT 6
								BLD		BORDER,0	; 
		LSL		VDATA0								; PREPARE BIT 5
		OUT		PORTB,VDATA0						; SET BIT 5
								ADD		ZH,BORDER	; 
		LSL		VDATA0								; PREPARE BIT 4
		OUT		PORTB,VDATA0						; SET BIT 4
		NOP											;  
		LSL		VDATA0								; PREPARE BIT 3
		OUT		PORTB,VDATA0						; SET BIT 3
		NOP											;  
		LSL		VDATA0								; PREPARE BIT 2
		OUT		PORTB,VDATA0							; SET BIT 2
		NOP											;  
		LSL		VDATA0								; PREPARE BIT 1
		OUT		PORTB,VDATA0						; SET BIT 1
		NOP											; 
		LSL		VDATA0								; PREPARE BIT 0
		OUT		PORTB,VDATA0						; SET BIT 0
		POP		BUF									; PREPARE NEXT ATRIBUT
			
		OUT		PORTB,VDATA30						; SET BIT 7
		OUT		PORTE,BUF							; SET ATRIBUT
		LSL		VDATA30								; PREPARE BIT 6
		OUT		PORTB,VDATA30						; SET BIT 6
		NOP											;  
		LSL		VDATA30								; PREPARE BIT 5
		OUT		PORTB,VDATA30						; SET BIT 5
		NOP											;  
		LSL		VDATA30								; PREPARE BIT 4
		OUT		PORTB,VDATA30						; SET BIT 4
		NOP											;  
		LSL		VDATA30								; PREPARE BIT 3
		OUT		PORTB,VDATA30						; SET BIT 3
		NOP											;  
		LSL		VDATA30								; PREPARE BIT 2
		OUT		PORTB,VDATA30						; SET BIT 2
								IN		BORDER,TMPBORD; PREPARE CURRENT BORDER
		LSL		VDATA30								; PREPARE BIT 1
		OUT		PORTB,VDATA30						; SET BIT 1
								LDI		BUF,128		; CONST128
		LSL		VDATA30								; PREPARE BIT 0
		OUT		PORTB,VDATA30						; SET BIT 0
		POP		VDATA0								; PREPARE NEXT ATRIBUT
		
		OUT		PORTB,VDATA31						; SET BIT 7
		OUT		PORTE,VDATA0						; SET ATRIBUT
		LSL		VDATA31								; PREPARE BIT 6
		OUT		PORTB,VDATA31						; SET BIT 6
								OUT		SPH,ZH		; SAVE NEW  
		LSL		VDATA31								; PREPARE BIT 5
		OUT		PORTB,VDATA31						; SET BIT 5
								OUT		SPL,ZL		; SP VALUE
		LSL		VDATA31								; PREPARE BIT 4
		OUT		PORTB,VDATA31						; SET BIT 4
								MOV		ZH,VDATA19	; 
		LSL		VDATA31								; PREPARE BIT 3
		OUT		PORTB,VDATA31						; SET BIT 3
								MOV		ZL,VDATA18	; 
		LSL		VDATA31								; PREPARE BIT 2
		OUT		PORTB,VDATA31						; SET BIT 2
								MOV		VDATA30,ZH	; 
		LSL		VDATA31								; PREPARE BIT 1
		OUT		PORTB,VDATA31						; SET BIT 1
								MOV		VDATA24,ZL	; 
		LSL		VDATA31								; PREPARE BIT 0
		OUT		PORTB,VDATA31						; SET BIT 0
								IN 	BORDER,TMPBORD	; 
		OUT		MCUCR,BUF							; ENABLE XMEM

.ENDMACRO



