;PORTB    7     6     5     4     3     2     1     0
;        CH11  CH10  CS   CDIN  CCLK  DINCS DOUTCS LRCK
;
;PORTD    7     6     5     4     3     2     1     0
;         -   RSTCS  CH5   CH4   CH3   CH2   CH1   CH0

;************************** REGISTER DEFINITIONS **************************************

.DEF		TMPSR	= R11
.DEF    	DIRD	= R12
.DEF    	CONSTFF	= R13
.DEF    	CONST55	= R14
.DEF    	ZERO	= R15
.DEF    	BUF    	= R16
.DEF    	BUFI   	= R17
.DEF    	ST1   	= R18
.DEF    	ST2   	= R19
.DEF    	ST3   	= R20
.DEF    	DATA  	= R22
.DEF		TMPI	= R23
.DEF    	INTDATA	= R24
.DEF		COLOMN6	= R25
.DEF		COLOMN7	= R26
.DEF    	CONTROL	= R27

.EQU   		A15  	= 7   					; PORT B
.EQU   		A14  	= 6   					; PORT B
.EQU   		A13		= 5   					; PORT B
.EQU   		A12  	= 4   					; PORT B
.EQU   		A11 	= 3   					; PORT B
.EQU   		A10  	= 2   					; PORT B
.EQU   		A9	 	= 1   					; PORT B
.EQU   		A8	  	= 0   					; PORT B

.EQU   		KEYCLK 	= 6   					; PORT D
.EQU   		KEYM  	= 5   					; PORT D
.EQU   		INTFLG 	= 5   					; PORT D
.EQU   		KEYDATA	= 4   					; PORT D
.EQU   		KEYH  	= 4   					; PORT D
.EQU   		KEYMH  	= 3   					; PORT D
.EQU   		MHz21 	= 2   					; PORT D
.EQU   		KEYML 	= 1   					; PORT D
.EQU   		INTF12 	= 1   					; PORT D
.EQU   		KEYL 	= 0   					; PORT D
.EQU   		INTF11 	= 0   					; PORT D

.EQU   		BITE0 	= 7   					; PORT DCONTROL
.EQU   		BITF0 	= 6   					; PORT DCONTROL
